#ifndef GLOABAL_FUN
#define GLOABAL_FUN
#include "stdafx.h"
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "MyImage.h"


float **make_2D_float_array(int row,int col);
void free_2D_float_array(float **arr);

int **make_2D_int_array(int row,int col);
void free_2D_int_array(int **arr);

CPoint coordinate_change(CPoint p, int shift_h, int shift_v, float ori);
CPoint inverse_coordinate_change(CPoint ip, int shift_h, int shift_v, float ori);
//float dist(CPoint 1, CPoint 2);

int inside(CPoint p, CPoint tile[4], int shift_h, int shift_v, float ori);

bool check_boundary(CPoint *p, int IMAGE_WIDTH, int IMAGE_HEIGHT);

float **compute_gradient(MyImage *im,float ***edge);

bool if_complete(CPoint center, float ori, int image_width, int image_height, int width, int height);

float **image_rotate(float **image,int width, int height,float angle, int *nwidth, int *nheight);

float **computeDistanceMap(float **func, int width, int height);
float computeGap(float **ori_map, int **process, CPoint center, int image_width, int image_height,int width, int height, int region_size, int tile_number);

bool if_Intersect(float **ori_map, CPoint center1, CPoint center2, int image_width, int image_height,int width, int height);
#endif