#pragma once

#ifndef PRI_QUEUE
#define PRI_QUEUE

#include "stdafx.h"
#include <queue>

using namespace std;

class Node
{
public:
	Node *next;
	CPoint point;
	float weight;

	Node(void);
};

class CompareNode
{
public:
	bool operator()(Node& node1, Node& node2)
	{
		if(node1.weight > node2.weight)return true;
		if(node1.weight == node2.weight)return false;
		return false;
		//if(abs(node1.point.x)+abs(node1.point.y) > abs(node2.point.x)+abs(node2.point.y))return true;
		//if(abs(node1.point.x)+abs(node1.point.y) == abs(node2.point.x)+abs(node2.point.y))return true;
		//return false;

	}
};

class Queue
{
private:
	Node *head;
	priority_queue<Node, vector<Node>, CompareNode> queue;
	

public:
	Queue(void);
	Node *dequeue(void);
	bool inqueue(CPoint p, float weight);
	int size;
	Node *Head(void){return head;}
	//Node *search(CPoint p);
};



#endif