#ifndef LABEL_SET
#define LABEL_SET

#include "stdafx.h"
#include "MyImage.h"
#include "Label.h"
#include "gloabalFunctions.h"
#include <stdio.h>

class LabelSet
{
public:
	LabelSet(MyImage *I_image, float **I_ori_map);
	LabelSet();
	~LabelSet();
	int addLabel(int width, int height,float **sites);
	Label *getLabel(int ID);
	int getLabelNum();
	int getImageWidth();
	int getImageHeight();
	
private:
	Label labels[MAX_LABEL];
	int num_label;
	float **ori_map;
	MyImage *image;
	int image_width;
	int image_height;
};

#endif