#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "priority_queue.h"
#include "MyImage.h"
#include "gloabalFunctions.h"
#include "mosaic.h"
#include "stdafx.h"


void main(int argc, char **argv)
{
	if(argc < 4)
	{
		printf("mosaic input_image_name tile_size output_image_name\n");
		printf("Use bmp images.\n");
		exit(0);
	}
	MyImage im;
	int readImage = im.ReadMyImage(argv[1]);
	if(readImage == 0)
	{
		printf("Can not open input image.\n");
		exit(0);
	}

	int tileSize = atoi(argv[2]);
	Mosaic mosaic(&im,tileSize,tileSize,32);
	mosaic.generateMosaic();
	mosaic.visualizeTile(argv[3]);
}